Forums

Skip to content

Advanced search
  • Quick links
    • Unanswered topics
    • Active topics
    • Search
  • FAQ
  • Login
  • Register
  • Board index Discussion & Documentation Documentation, Tips & Tricks
  • Search

[HOWTO]New freetype subpixel font rendering for lcd monitors

Unofficial documentation for various parts of Gentoo Linux. Note: This is not a support forum.
Locked
Advanced search
728 posts
  • Page 11 of 30
    • Jump to page:
  • Previous
  • 1
  • …
  • 9
  • 10
  • 11
  • 12
  • 13
  • …
  • 30
  • Next
Author
Message
ExZombie
Apprentice
Apprentice
Posts: 170
Joined: Sat May 29, 2004 2:05 pm

Post by ExZombie » Sun Jul 01, 2007 8:24 pm

Funny. I've been pondering about this "smeared" pixels for a long time and your screenshot makes is way easier to explain.

You see, all of my fonts look like your kcontrol. If I make a screenshot and zoom in, I see exactly the same. The funny thing is, (and that's what I've been wondering about) without zooming in, I don't see that "smear". I guess that means the way the fonts are rendered fits my LCD panel perfectly. Is that correct? It makes some sense.

If that's true then it would explain why I can't see what you're complaining about. Your kcontrol looks better than your firefox on my panel :) . Unfortunately, I can't answer why they look different in the first place.

FYI, I'm using VRGB sub-pixel rendering. I guess you need RGB.
Top
Da Fox
Guru
Guru
User avatar
Posts: 345
Joined: Wed Jul 06, 2005 12:03 am

Post by Da Fox » Mon Jul 02, 2007 12:33 pm

I've tried both RGB and BGR (even though I know my LCD has RGB ordering), but the fonts are rendered exactly the same. (Do I need to restart X for changes in the subpixel ordering to take effect? All other things such as hinting and anti-aliasing immediately affect newly started applications.). The are all rendered like the screenshot, orange on the left, blue on the right. Should that not reverse when I change from RGB to BGR ordering?

Further, I've been looking at all the screenshots posted in this topic, and they all show this blur. Also the 'original' screenshot, the one posted to some mailing list, has the same 'blur'. I guess that means that this is the way the fonts are supposed to look?

But if that is so then I don't understand what hinting does, because as far as I know 'hinting' is the process of adapting the shape of font glyphs before they are sent to the rasterizer such that certain features and shapes are retained, for example forcing the stems of the letter 'm' to fall in integral pixels. (See the screenshot in this wiki link, and some more explanation on font rasterization here). From what I see it looks as if there is something wrong with the font hinting in this new subpixel renderer?

In either case, I don't like it, and would really prefer my KDE fonts to look the way my GTK are and always have looked. Isn't there anyway I can tell KDE to use Cairo for font rendering, or am I spouting nonsense here... :)
(I think maybe cairo and qt are two different implementations of the same thing, I think this holds true at least for Qt4, but I don't really know anything about cairo or qt other than that one looks pwitty and the other does not :p)
"Man fears the darkness, and so he scrapes away at the edges of it with fire."
- Rei Ayanami

JGBE, a Java based GameBoy Emulator
Top
enderandrew
l33t
l33t
User avatar
Posts: 731
Joined: Tue Oct 25, 2005 8:37 am

Post by enderandrew » Tue Jul 03, 2007 6:27 am

Given that even the Trolltech guys are pushing for universal text layout with Pango, I think we'll be at a point very soon when text rendering is all the same on Linux boxes, if not all boxes that wish to take advantage of stuff like Pango.
Nihilism makes me smile.
Top
Da Fox
Guru
Guru
User avatar
Posts: 345
Joined: Wed Jul 06, 2005 12:03 am

Post by Da Fox » Tue Jul 03, 2007 12:41 pm

YES!
I finally found /some/ proof that is *should* be possible to get nice anti-aliasing even in kde/qt: screenshot
This came from the Arch-linux forums, bij someone named 'emmybear' (second post from the top). As you can see, all text is rendered the way I want it, with 'pixel-perfect-hinting', and the screenshot appears to be taken from KDE, as you can see the characteristic KDE taskbar, konqueror and konsole.
Now I've tried what he/she said (put only the DPI setting in local.conf, and AA and hinting max in kcontrol), but it doesn't help, fonts are still rendered blurry* in Qt and sharp** in GTK, and in fact I can't tell anything is different from before :(.

I really don't understand, don't qt and gtk _both_ use the *same* font.conf, and don't they _both_ render text ultimately with freetype?



* **: relative to my point of view / preference


--edit:
And yet another small step in the right direction:
I've discovered that the 'blur' is actually a new 'lcd filter', and that the lcd filtering that I want is now called 'legacy lcd filter'.
Here is a pretty good explanation of it: http://www.mail-archive.com/freetype-de ... 01846.html
Basically it says that incase you have very good byte-code-hinted fonts (which I do, as I mostly use bitstream-vera) this filter is sharper than the new filter, but in all other cases is better to use the new filter.
A nice way to see the difference is to use the 'ftdiff' tool, it allows you to change a lot of parameters on-the-fly. (press F1 for a quick overview).
For example to view bitstream-vera-sans rendered at 96 dpi, fontsize 12 you'd do:

Code: Select all

ftdiff -r 96 -s 12 /usr/share/fonts/ttf-bitstream-vera/Vera.ttf
So now I need to know where I can select which lcd filter to use, and tell it that I want it to use the legacy filter. Does anyone know how to do that? Can it be done through .fonts.conf/fonts.local?
"Man fears the darkness, and so he scrapes away at the edges of it with fire."
- Rei Ayanami

JGBE, a Java based GameBoy Emulator
Top
boniek
Guru
Guru
User avatar
Posts: 373
Joined: Sat Mar 26, 2005 6:02 pm

Post by boniek » Wed Jul 04, 2007 2:59 am

David Turner wrote:The "legacy" LCD filter corresponds to the current implementation found in LibXft and Cairo
If you want effect like the other guy don't use this overlay at all. Install cairo, libxft from portage, enable bytecode interpreter and disable autohinter. If that won't work, at some point in xeffects overlay you could choose what filter you want by setting appropriate use flag. Look through older revisions of freetype ebuild to see how that can be done (I've removed them because Turner considers legacy filter deprecated).
[HOWTO]New freetype subpixel font rendering for lcd monitors
Top
IvanMajhen
Guru
Guru
User avatar
Posts: 392
Joined: Sat Jun 10, 2006 11:38 am
Location: Croatia

Post by IvanMajhen » Wed Jul 04, 2007 12:15 pm

I just tested ftdiff with freetype 2.3.5, and in my opinion lcd filter light is the best for me. Can we set this filter with fontconfig?
I modified freetype that it uses lcd filter light by default.

Screenshot:
http://shrani.si/files/snapshot513c7b.png
Top
roderick
l33t
l33t
User avatar
Posts: 908
Joined: Mon Jul 11, 2005 3:06 pm
Location: St. John's, NL CANADA
Contact:
Contact roderick
Website

Post by roderick » Wed Jul 04, 2007 2:15 pm

boniek,

Cairo 1.4.10 wasn't bumped in the overlay yet. We need to keep on top of these bumps, as users may install these unwittingly and cause problems.

This was bumped on June 28th.

For anyone who has currently installed cairo 1.4.10, you do not have the newspr patch. Either go back to 1.4.8 from overlay or re-emerge cairo 1.4.10 (as soon as I have had a chance to update the overlay).

Hopefully, we can get this updated today.

Cherers,

Rod.
If God were a pickle, I'd still say "no pickle on my burger".
http://roderick-greening.blogspot.com/
Top
roderick
l33t
l33t
User avatar
Posts: 908
Joined: Mon Jul 11, 2005 3:06 pm
Location: St. John's, NL CANADA
Contact:
Contact roderick
Website

Post by roderick » Wed Jul 04, 2007 2:43 pm

Ok. Cairo updated.

Please re-emerge if you had previously installed 1.4.10 from portage.

emerge -1v cairo pango gtk+

Cherrs,

Rod.
If God were a pickle, I'd still say "no pickle on my burger".
http://roderick-greening.blogspot.com/
Top
PaulBredbury
Watchman
Watchman
User avatar
Posts: 7310
Joined: Thu Jul 14, 2005 3:47 pm

Post by PaulBredbury » Wed Jul 04, 2007 3:16 pm

IvanMajhen wrote:light is the best for me.
In ~/.fonts.conf

Code: Select all

    <!-- hintnone, hintslight, hintmedium, hintfull -->
    <match target="font">
        <edit name="hintstyle" mode="assign"><const>hintslight</const></edit>
    </match>
Top
anli
Tux's lil' helper
Tux's lil' helper
Posts: 80
Joined: Fri Sep 08, 2006 8:59 pm

Post by anli » Wed Jul 04, 2007 3:20 pm

BTW, freetype 2.3.5 is in official ~portage now.
Top
IvanMajhen
Guru
Guru
User avatar
Posts: 392
Joined: Sat Jun 10, 2006 11:38 am
Location: Croatia

Post by IvanMajhen » Wed Jul 04, 2007 3:53 pm

PaulBredbury wrote:
IvanMajhen wrote:light is the best for me.
In ~/.fonts.conf

Code: Select all

    <!-- hintnone, hintslight, hintmedium, hintfull -->
    <match target="font">
        <edit name="hintstyle" mode="assign"><const>hintslight</const></edit>
    </match>
This is not what i'm looking for. This is hinting style.

#elif defined( FT_FORCE_LIGHT_LCD_FILTER ) ---> i wan't this to set with fontconfig. I patched freetype to use this and fonts look much smoother.
Top
PaulBredbury
Watchman
Watchman
User avatar
Posts: 7310
Joined: Thu Jul 14, 2005 3:47 pm

Post by PaulBredbury » Wed Jul 04, 2007 4:48 pm

Yes, the fonts are a bit crisper:

Code: Select all

diff -u freetype-2.3.4_p20070428.ebuild-orig freetype-2.3.4_p20070428.ebuild
--- freetype-2.3.4_p20070428.ebuild-orig        2007-07-04 17:46:27.000000000 +0100
+++ freetype-2.3.4_p20070428.ebuild     2007-07-04 17:46:27.000000000 +0100
@@ -12,7 +12,7 @@
 LICENSE="FTL GPL-2"
 SLOT="2"
 KEYWORDS=""
-IUSE="demos zlib bindist doc"
+IUSE="demos zlib bindist doc light"
 
 # The RDEPEND below makes sure that if there is a version of moz/ff/tb
 # installed, then it will have the freetype-2.1.8+ binary compatibility patch.
@@ -57,6 +57,12 @@
 
        disable_option FT_CONFIG_OPTION_OLD_INTERNALS
 
+       if use light ; then
+               sed -i \
+                       -e "/FT_END_HEADER/i\#define FT_FORCE_LIGHT_LCD_FILTER" \
+                       include/freetype/config/ftoption.h || die "sed ftoption.h light"
+       fi
+
        elibtoolize
        epunt_cxx
 }
Top
IvanMajhen
Guru
Guru
User avatar
Posts: 392
Joined: Sat Jun 10, 2006 11:38 am
Location: Croatia

Post by IvanMajhen » Wed Jul 04, 2007 7:18 pm

This is what i'm talking about. 8) They also look better to me.
I thought that there is some fontconfig option, and not hardcoding this in freetype.
This should go into xeffects.
Top
Da Fox
Guru
Guru
User avatar
Posts: 345
Joined: Wed Jul 06, 2005 12:03 am

Post by Da Fox » Wed Jul 04, 2007 7:28 pm

boniek wrote:
David Turner wrote:The "legacy" LCD filter corresponds to the current implementation found in LibXft and Cairo
If you want effect like the other guy don't use this overlay at all. Install cairo, libxft from portage, enable bytecode interpreter and disable autohinter. If that won't work, at some point in xeffects overlay you could choose what filter you want by setting appropriate use flag. Look through older revisions of freetype ebuild to see how that can be done (I've removed them because Turner considers legacy filter deprecated).
That won't be necessary, all I needed was PaulBredBury's patch, with a minor modification, thanks for the hint though :)
PaulBredbury wrote:Yes, the fonts are a bit crisper:

Code: Select all

diff -u freetype-2.3.4_p20070428.ebuild-orig freetype-2.3.4_p20070428.ebuild
--- freetype-2.3.4_p20070428.ebuild-orig        2007-07-04 17:46:27.000000000 +0100
+++ freetype-2.3.4_p20070428.ebuild     2007-07-04 17:46:27.000000000 +0100
@@ -12,7 +12,7 @@
 LICENSE="FTL GPL-2"
 SLOT="2"
 KEYWORDS=""
-IUSE="demos zlib bindist doc"
+IUSE="demos zlib bindist doc light"
 
 # The RDEPEND below makes sure that if there is a version of moz/ff/tb
 # installed, then it will have the freetype-2.1.8+ binary compatibility patch.
@@ -57,6 +57,12 @@
 
        disable_option FT_CONFIG_OPTION_OLD_INTERNALS
 
+       if use light ; then
+               sed -i \
+                       -e "/FT_END_HEADER/i\#define FT_FORCE_LIGHT_LCD_FILTER" \
+                       include/freetype/config/ftoption.h || die "sed ftoption.h light"
+       fi
+
        elibtoolize
        epunt_cxx
 }
Yes! Finally my fonts look exactly the way I like them, even in KDE :D
Thank you so much, you saved me a lot of work going through old ebuilds :)
For the record: changing the sed line from the above ebuild to

Code: Select all

sed -i -e "/FT_END_HEADER/i\#define FT_FORCE_LEGACY_LCD_FILTER" include/freetype/config/ftoption.h || die "sed ftoption.h LEGACY_LCD_FILTER_HAX"
will force freetype to use the legacy lcd filter.
"Man fears the darkness, and so he scrapes away at the edges of it with fire."
- Rei Ayanami

JGBE, a Java based GameBoy Emulator
Top
PaulBredbury
Watchman
Watchman
User avatar
Posts: 7310
Joined: Thu Jul 14, 2005 3:47 pm

Post by PaulBredbury » Wed Jul 04, 2007 7:59 pm

Here's a tidied ebuild which adds 2 new USE flags: light and legacy. Plus some minor tidying :)
Top
Nah
Tux's lil' helper
Tux's lil' helper
User avatar
Posts: 107
Joined: Mon May 01, 2006 8:44 am
Location: Lille,France

Post by Nah » Sat Jul 07, 2007 12:57 pm

PaulBredbury wrote:Here's a tidied ebuild which adds 2 new USE flags: light and legacy. Plus some minor tidying :)
Link don't work. :(
Top
PaulBredbury
Watchman
Watchman
User avatar
Posts: 7310
Joined: Thu Jul 14, 2005 3:47 pm

Post by PaulBredbury » Sat Jul 07, 2007 1:35 pm

rafb must only keep it for a day or two. Here's the ebuild:

/usr/local/portage/media-libs/freetype/freetype-2.3.4_p20070428.ebuild

Code: Select all

# Copyright 1999-2007 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: $

inherit eutils flag-o-matic libtool

DESCRIPTION="A high-quality and portable font engine"
HOMEPAGE="http://www.freetype.org/"
SRC_URI="http://manta.univ.gda.pl/~rbonieck/${P}.tar.gz
	doc? ( mirror://sourceforge/${PN}/${PN}-doc-2.3.4.tar.bz2 )"

LICENSE="FTL GPL-2"
SLOT="2"
KEYWORDS=""
IUSE="bindist demos doc legacy light zlib"

# The RDEPEND below makes sure that if there is a version of moz/ff/tb
# installed, then it will have the freetype-2.1.8+ binary compatibility patch.
# Otherwise updating freetype will cause moz/ff/tb crashes. #59849
# 20 Nov 2004 agriffis
DEPEND="zlib? ( sys-libs/zlib )"

RDEPEND="${DEPEND}
	!<www-client/mozilla-1.7.3-r3
	!<www-client/mozilla-firefox-1.0-r3
	!<mail-client/mozilla-thunderbird-0.9-r3
	!<media-libs/libwmf-0.2.8.2"

S="${WORKDIR}/freetype2"

src_unpack() {
	unpack ${A}
	cd "${S}"

	enable_option() {
		sed -i -e "/#define $1/a #define $1" \
			include/freetype/config/ftoption.h \
			|| die "unable to enable option $1"
	}

	disable_option() {
			sed -i -e "/#define $1/ { s:^:/*:; s:$:*/: }" \
			include/freetype/config/ftoption.h \
			|| die "unable to disable option $1"
	}

	if ! use bindist ; then
		# Bytecodes and subpixel hinting supports are patented
		# in United States; for safety, disable them while building
		# binaries, so that no risky code is distributed.
		# See http://freetype.org/patents.html

		enable_option TT_CONFIG_OPTION_BYTECODE_INTERPRETER
		enable_option FT_CONFIG_OPTION_SUBPIXEL_RENDERING
		disable_option TT_CONFIG_OPTION_UNPATENTED_HINTING
	fi

	disable_option FT_CONFIG_OPTION_OLD_INTERNALS

	if use light ; then
		elog "Enabling FT_FORCE_LIGHT_LCD_FILTER."
		sed -i \
			-e "/FT_END_HEADER/i\#define FT_FORCE_LIGHT_LCD_FILTER" \
			include/freetype/config/ftoption.h || die "sed ftoption.h light"
	elif use legacy ; then
		elog "Enabling FT_FORCE_LEGACY_LCD_FILTER."
		sed -i \
			-e "/FT_END_HEADER/i\#define FT_FORCE_LEGACY_LCD_FILTER" \
			include/freetype/config/ftoption.h || die "sed ftoption.h legacy"
	fi

	elibtoolize
	epunt_cxx
}

src_compile() {
	# https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=118021
	append-flags "-fno-strict-aliasing"

	type -p gmake &> /dev/null && export GNUMAKE=gmake
	sh autogen.sh || die "autogen.sh"
	econf $(use_with zlib) || die "econf"

	emake || die "emake"

	if use demos ; then
		cd "${WORKDIR}"/ft2demos
		emake || die "emake ft2demos"
	fi
}

src_install() {
	emake -j1 DESTDIR="${D}" install || die "emake install"

	dodoc ChangeLog README docs/{CHANGES,CUSTOMIZE,DEBUG,*.txt,PATENTS,TODO}

	cd "${WORKDIR}/${PN}-doc-${PV}"
	use doc && dohtml -r docs/*

	if use demos ; then
		cd "${WORKDIR}"/ft2demos/bin/.libs || die
		dobin * || die "dobin demos"
	fi
}

pkg_postinst() {
	ewarn "DO NOT report bugs to Gentoo's bugzilla."
	elog "See http://forums.gentoo.org/viewtopic-t-511382.html for support."
	einfo "Thank you on behalf of the Gentoo Xeffects team."
}
Top
Nah
Tux's lil' helper
Tux's lil' helper
User avatar
Posts: 107
Joined: Mon May 01, 2006 8:44 am
Location: Lille,France

Post by Nah » Sat Jul 07, 2007 1:59 pm

Thank ! :P
Top
KejPi
Tux's lil' helper
Tux's lil' helper
User avatar
Posts: 122
Joined: Sat Jan 17, 2004 1:48 pm
Location: Prague, Czech republic

Post by KejPi » Tue Jul 10, 2007 5:14 pm

This is very interesting article http://antigrain.com/research/font_rast ... index.html.
It would be nice to achieve something what is shown in section labeled What can we do?

After all trials I am still not able to achieve nice "k" letter (using DejaVu sans font) :-( I am getting exactly what is shown in the article - at the end section Gamma does not Work!
Top
KejPi
Tux's lil' helper
Tux's lil' helper
User avatar
Posts: 122
Joined: Sat Jan 17, 2004 1:48 pm
Location: Prague, Czech republic

Post by KejPi » Tue Jul 10, 2007 5:20 pm

IvanMajhen wrote:This is what i'm talking about. 8) They also look better to me.
I thought that there is some fontconfig option, and not hardcoding this in freetype.
This should go into xeffects.
I can't see any difference :-(
Top
ExZombie
Apprentice
Apprentice
Posts: 170
Joined: Sat May 29, 2004 2:05 pm

Post by ExZombie » Fri Jul 13, 2007 5:38 pm

Mmmm, 'light' filter is only slightly better on my screen, but it's still better. Man, I love having a 130dpi display :P
There's just one little gripe I have which I've been trying to solve on and off for a while now. I can't seem to find out why some fonts tend to render the letter 'o' and letters 'N', 'M' and 'W' in funny ways. While DejaVu just rocks, I want to cry at this screenshot. I'm gonna take a look at the soruce to see which font this is.
Top
Eimai
n00b
n00b
Posts: 8
Joined: Sun Dec 17, 2006 7:46 pm

Post by Eimai » Fri Jul 13, 2007 8:20 pm

ExZombie wrote:I want to cry at this screenshot. I'm gonna take a look at the soruce to see which font this is.
That's Trebuchet MS, one of the corefonts.
Top
Belliash
Advocate
Advocate
User avatar
Posts: 2503
Joined: Wed Nov 24, 2004 1:39 pm
Location: Wroclaw, Poland
Contact:
Contact Belliash
Website

Post by Belliash » Tue Jul 17, 2007 8:45 am

This does not work for me...

I use it since this topic had just 2 pages and everytime worked for me, but not this time :(
I always set it in KDE to use sub-pixel hinting (RGB) and hinting style to Medium. This worked, but i have installed new Gentoo and now does not work :(

I have installed packages with USE:

[ebuild R ] media-libs/freetype-2.3.5 USE="X zlib -bindist -debug -doc" 0 kB
[ebuild R ] x11-libs/cairo-1.4.10 USE="X glitz newspr opengl svg -debug -directfb -doc -xcb" 0 kB [1]
[ebuild R ] x11-libs/libXft-2.1.12 USE="newspr -debug" 0 kB [1]

I tried downgrading freetype to latest from xeffects, cairo to 1.4.8 libXft to 2.1.11... None helped...

What i can say more?
When i disable antialiasing in KDE then fonts look ugly, but when enable it look prettier, but not the same like looked before. They look like i would have installed both cairo iand libXft with USE="-newspr" - old antialiasing, but as You can see i have enabled this flag...

So, whan can be wrong?

Thanks!
Asio Software Technologies
Belliash IT Weblog
Top
IvanMajhen
Guru
Guru
User avatar
Posts: 392
Joined: Sat Jun 10, 2006 11:38 am
Location: Croatia

Post by IvanMajhen » Tue Jul 17, 2007 11:42 am

Hinting must be full.
Top
Belliash
Advocate
Advocate
User avatar
Posts: 2503
Joined: Wed Nov 24, 2004 1:39 pm
Location: Wroclaw, Poland
Contact:
Contact Belliash
Website

Post by Belliash » Tue Jul 17, 2007 12:23 pm

IvanMajhen wrote:Hinting must be full.
1) was medium and worked...
2) no difference when set to full...
Asio Software Technologies
Belliash IT Weblog
Top
Locked

728 posts
  • Page 11 of 30
    • Jump to page:
  • Previous
  • 1
  • …
  • 9
  • 10
  • 11
  • 12
  • 13
  • …
  • 30
  • Next

Return to “Documentation, Tips & Tricks”

Jump to
  • Assistance
  • ↳   News & Announcements
  • ↳   Frequently Asked Questions
  • ↳   Installing Gentoo
  • ↳   Multimedia
  • ↳   Desktop Environments
  • ↳   Networking & Security
  • ↳   Kernel & Hardware
  • ↳   Portage & Programming
  • ↳   Gamers & Players
  • ↳   Other Things Gentoo
  • ↳   Unsupported Software
  • Discussion & Documentation
  • ↳   Documentation, Tips & Tricks
  • ↳   Gentoo Chat
  • ↳   Gentoo Forums Feedback
  • ↳   Duplicate Threads
  • International Gentoo Users
  • ↳   中文 (Chinese)
  • ↳   Dutch
  • ↳   Finnish
  • ↳   French
  • ↳   Deutsches Forum (German)
  • ↳   Diskussionsforum
  • ↳   Deutsche Dokumentation
  • ↳   Greek
  • ↳   Forum italiano (Italian)
  • ↳   Forum di discussione italiano
  • ↳   Risorse italiane (documentazione e tools)
  • ↳   Polskie forum (Polish)
  • ↳   Instalacja i sprzęt
  • ↳   Polish OTW
  • ↳   Portuguese
  • ↳   Documentação, Ferramentas e Dicas
  • ↳   Russian
  • ↳   Scandinavian
  • ↳   Spanish
  • ↳   Other Languages
  • Architectures & Platforms
  • ↳   Gentoo on ARM
  • ↳   Gentoo on PPC
  • ↳   Gentoo on Sparc
  • ↳   Gentoo on Alternative Architectures
  • ↳   Gentoo on AMD64
  • ↳   Gentoo for Mac OS X (Portage for Mac OS X)
  • Board index
  • All times are UTC
  • Delete cookies

© 2001–2026 Gentoo Foundation, Inc.

Powered by phpBB® Forum Software © phpBB Limited

Privacy Policy